#include <stdio.h>
#include <string.h>
#include "common.h"
#include "matrix.h"

#define SEP " \t"

struct matrix_t *
m_read(const char *fname)
{
	FILE	*fp;
	int	i, j,  size;
	char	line[256], *p, *q;
	struct matrix_t *retm;
	float	**mat, tmp;
	int	readn;

	fp = fopen(fname, "r");
	if (fp == NULL)
		fatal("%s(): fopen", __F);

	p = fgets(line, 256, fp);
	if (p == NULL)
		fatal("%s(): fgets", __F);

	readn = sscanf(line, "%d", &size);
	if (readn != 1 || size <= 1)
		fatal("%s(): scanf", __F);

	retm = matrix(size, size, NULL, SP_SINGLE);
	mat = smat(retm);

	for (i=0;i<size;i++) {
		p = fgets(line, 256, fp);
		if (p == NULL)
			fatal("%s(): fgets", __F);

		for (j=0; (q = strtok(p, SEP)) && j < size; p = NULL, j++) {
			readn = sscanf(q, "%f", &tmp);
			if (readn != 1)
				fatal("%s(): scanf", __F);
			mat[i][j] = tmp;
		}
	}
	fclose(fp);
	return retm;
}

void
m_mkband(struct matrix_t *am, const int band)
{
	float	**mat;
	int	i, j;

	mat = smat(am);
	for (i=0;i<am->mt_col; i++) {
		for (j=0;j<am->mt_col; j++) {
			if (abs(i-j) > band)
				mat[i][j] = 0.0;
		}
	}
	return;
}
