#ifndef H_LU_H
#define H_LU_H

#include "sparse.h"

#define SPE_ROW		0x01
#define SPE_COL		0x02

struct spentry_t
{
	int	 spe_flag;	/* indicator col or row */
	int	 spe_no;	/* col no or row no */
	int	 spe_memno;	/* total no of the entries of this row/col */
	int	 spe_alloced;	/* the space of alloced */
	int	 spe_mmax[2];	/* min and max of the no's of this row/col */
	int	*spe_index;	/* correspongding... */
	int	*spe_data;	/* the real data location */
};

struct splowup_t
{
	int	splu_size;
	int	splu_flag;
	int	splu_type;
	struct spentry_t **splu_entries;	/* for each cols */
};

struct spforlu_t
{
	int		  spf_size;	/* size..ie..no of rows */
	int		  spf_type;
	struct splowup_t *spf_lower;	/* lower part */
	struct splowup_t *spf_upper;	/* upper part */
	int		 *spf_perm;	/* permute */
	int		  spf_parity;	/* parity of permutation */
};

struct spforlu_t *splu_init(struct sparse_t *sp);
struct spforlu_t *sp_ludecomp(struct sparse_t *sp, const int dopivot);
void		  sp_lubacksub(struct spforlu_t *spf, struct vector_t *bv);
void	 splu_print(const struct spforlu_t *spf);
void	 splu_pattern(const struct spforlu_t *spf);
float	*splu_swhereis(const struct spforlu_t *spf, const int r, const int c);
float	*splu_sgiveme(const struct spforlu_t *spf, const int r, const int c);
void	 splu_rowchange(struct spforlu_t *spf, const int this, const int that);
void	 splue_print(const struct spentry_t *spe);
void	 splu_check(const struct spforlu_t *spf, const char *name);
float	 splu_all(const struct spforlu_t *spf);
void	 splu_rowput(const struct spforlu_t *spf, const int row);

#endif
