#include <stdio.h>
#include "common.h"
#include "mesh.h"

/*
 * In the case of 3-dimensional, I want to output at mtv format
 */
void
put_grid4headers(const char *filename)
{
	FILE	*fp;
	int	i;
	char	**cpp;
	char	*headers[]= {"$ DATA=GRID4D",
		"% interp=2",
		"% axisscale=f",
		"#% meshplot",
		"% nsteps=50",
		NULL,
	};
	char *minmax[3][2]={{"xmin", "xmax"}, {"ymin","ymax"}, {"zmin","zmax"}};
	char *nums[3]={"nx", "ny", "nz"};

	if (meshes->m_spacedim != 3) {
		printf("putgrid4form(): This is not 3-dim problem!!");
		return;
	}

	fp = fopen(filename, "w");
	if (fp == NULL)
		fatal("put_grid4headers(\"%s\"): can not open", filename);
	cpp = headers;

	while (*cpp)
		fprintf(fp, "%s\n", *cpp++);

	fprintf(fp, "\n");
	for (i=0;i<3;i++) {
		fprintf(fp, "%% ");
		fprintf(fp, "%s=%f ", minmax[i][0], meshes->m_coormin[i]);
		fprintf(fp, "%s=%f ", minmax[i][1], meshes->m_coormax[i]);
		fprintf(fp, "%s=%d\n",
			nums[i], meshes->m_for3dim->f3d_howmany[i]);
	}
	fclose(fp);
	return;
}
