#ifndef H_PROTO_H
#define H_PROTO_H

struct vector_t;
struct matrix_t;
struct proto_t;


int	tri3_init(struct proto_t *);
int	tri6_init(struct proto_t *);
int	sq4_init(struct proto_t *);
int	sq8_init(struct proto_t *);
int	sq9_init(struct proto_t *);
int     cub8_init(struct proto_t *);

extern struct proto_t *protop[9];

struct integral_t {
	struct proto_t   *intg_proto;	/* its proto_t */
	int		  intg_elemno;	/* the emenent no of this info */
	double		 *intg_jacob;	/* jacobs of the intg points */
	nodno_t		 *intg_nodes;	/* the surrounding nodes info */

	struct matrix_t	 *intg_coors;	/* coors of the surr. nodes */
	struct matrix_t  *intg_realintgcoors; /* real integ points */
	struct matrix_t	**intg_deriv;	/* the deriv's at  */
	struct matrix_t	**intg_jacobm;	/* the jacob matrix at the intg points*/

	/*
	 * following will not be changes I think. That is, following info is
	 * common information.
	 */
	double		 *intg_weights;	/* weights */
	struct matrix_t	 *intg_intgcoors;/* coors of the integration at master*/
	struct matrix_t	**intg_halfjacobm;
	struct matrix_t	 *intg_unit;	/* at unit frame */
	int		 *intg_unitflag;
	struct matrix_t	 *intg_trans;
	struct matrix_t	 *intg_tmp;	/* temporay */

	/*
	 * following will not be used ???
	 */
	struct matrix_t	**intg_hjatcorners;
	struct matrix_t	**intg_derivatcorners;
	struct matrix_t	**intg_jacobmatcorners;
};

struct proto_t {
	int      p_index;
	char    *p_name;
	int      p_nodsno;
	int      p_dimen;
	int      p_intgno;
	int	 p_linesegno;
	int	*p_lineseg;
	struct integral_t *p_intg;
	int    (*p_init)(struct proto_t *);
};


extern struct integral_t *intp[10];
extern struct proto_t protos[];
extern struct proto_t   *currp;         /* current struct proto_t */
extern int      currp_index;

void		 integral_init(struct proto_t *);
int     	 proto_null(struct proto_t *);
struct proto_t  *getproto(const char *);
int    		 proto_init(void);
void		 proto_einit(const int elemno);

#endif
