#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include "common.h"

void
fatal(const char *fmt, ...)
{
	char	line[128];
	va_list ap;
	va_start(ap, fmt);

	(void)fprintf(stderr, "fatal error:\n");
#if 0
	perror("");
#endif
	(void)vfprintf(stderr, fmt, ap);
	va_end(ap);
	(void)fprintf(stderr, "\n\nCongratulation!!! You met a bug\n");
	(void)fprintf(stderr, "Type any charater!!\n");
	gets(line);
	exit(1);
	/* NOTREACHED */
}

void
memerr(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);

	(void)fprintf(stderr, "memory error: ");
	(void)vfprintf(stderr, fmt, ap);
	va_end(ap);
	(void)fprintf(stderr, "\n");
	exit(1);
	/* NOTREACHED */
}

void
err(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);

	(void)fprintf(stderr, "err error: ");
	(void)vfprintf(stderr, fmt, ap);
	va_end(ap);
	(void)fprintf(stderr, "\n");
}


int
islineok(const char *line)
{
	char *p;

	for (p = (char *) line; isspace(*p); p++)
		/* void */;
	if (*p)
		return 1;
	return 0;
}

char *
skipto(const char *line, char c)
{
	char	*p;
	if (line == NULL)
		fatal("skipto() fatal");

	p = index(line, c);
	if (p == NULL)
		return (char *) NULL;
	return p;
}


void
bitput(int n, char *buf)
{
	int	i;
	char	*q=buf;

	if (buf == NULL)
		fatal("OOPS.. you must be a stupid one!!");
	q[32] = 0;
	for (i=0; i < 32; i++) {
		*q++ = (n & 0x1) ? '1' : '.';
		n >>= 1;
	}
	return;
}

float
sign(float x)
{
	if (x > 0.0)
		return 1.0;
	else
		return -1.0;
}


char *
skipwhites(char *p)
{
	char *q;

	for (q=p; isspace(*q); q++)
		/* void */ ;

	if (*q == NULL)
		fatal("White spaces??? Nothing left in this string!!");

	return q;
}
#define OK_NO(c) (isdigit(c) || (c == 'e') || index("+-", c))
char *
skipnumer(p)
	char *p;
{
	if (!OK_NO(*p) && *p != '.')
		fatal("skipnumer(): while reading %s", p);
	while (OK_NO(*p) || *p == '.')
		p++;

	return p;
}
#undef OK_NO
