#include <stdio.h>
#include <stdlib.h>

#include "common.h"
#include "finite.h"

int
main(int argc, char *argv[])
{
	int	which;

	if (argc != 2)
		fatal("%s(): need an argument", __F);
	mesh_init(SP_SINGLE);

	which = atoi(argv[1]);

	switch (which) {
		case 0:
			tri_getmesh("dd.1");
			break;
		case 1:
			tri_getmesh("ddd.1");
			break;
		case 2:
			genm_linear("d=2 [0.0:10.0]x[0.0:10.0]",
				"d=2 [20:20] [1.0:1.0]");
			break;
		case 3:
			genm_linear("d=3 [0.0:10.0]x[0.0:10.0]x[0.0:10.0]",
				"d=3 [10:10:10] [1.0:1.0:1.0]");
			break;
		default:
			fatal("%s(): which is not good!", __F);
	}
	put_2dgrids("grids.mtv", 0);

	meshes->m_kmatrix = create_kmatrix();
	meshes->m_bvector = create_bvector();

	problem();
	(void) printf("End of processing of\n");
	return 0;
}
