#include <stdio.h>
#include "common.h"
#include "finite.h"

void	usage(void);

int
main(int argc, char *argv[])
{
	/*
	 * Setup mesh global structure
	 * You should call these two function!!!!
	 * TRUE of mesh_init(complexornot) means that the whole structure will
	 * use complex variable... I mean, K-mat b-mat etc are complex structure
	 * when you gave me TRUE argument.
	 */
	mesh_init(SP_SINGLE);

#if 0
	genm_linear("d=3 [0.0:10.0]x[0.0:10.0]x[0.0:10.0]",
		"d=3 [5:5:5] [1.0:1.0:1.0]");
#else
	genm_linear("d=2 [-1.0:1.0]x[-1.0:1.0]",
		"d=2 [20:20] [1.0:1.0]");
	dp_putmesh("b.grids");
#endif

	meshes->m_kmatrix = create_kmatrix();
	meshes->m_bvector = create_bvector();

	problem();
	printf("End of processing of\n");
	return 0;
}

void
usage(void)
{
	printf("usage: a.out filename\n");
	exit(1);
}
