#include <stdio.h>

#include "common.h"
#include "finite.h"

/*
 * \nabla \phi(x,y) = 0 with the following Dirichlet
 *
 * \phi(0, y) = -10
 * \phi(1, y) =  10
 * \phi(x, 0) =  10
 * \phi(x, 1) = -10
 */

int
main(void)
{
	mesh_init(SP_SINGLE);

#if 0
	genm_linear("d=3 [0.0:10.0]x[0.0:10.0]x[0.0:10.0]",
		"d=3 [5:5:5] [1.0:1.0:1.0]");
#elif 1
	genm_linear("d=2 [0.0:10.0]x[0.0:10.0]",
		"d=2 [20:20] [1.0:1.0]");
#else
	genm_quadrat(1, "d=2 [0.0:10.0]x[0.0:10.0]",
		"d=2 [10:10] [1.0:1.0]");

#endif
	if (0)
		dp_putmesh("tri");

	meshes->m_kmatrix = create_kmatrix();
	meshes->m_bvector = create_bvector();

	put_2dgrids("grids.mtv", 0);
	problem();
	printf("End of processing of\n");

	return 0;
}
