#ifndef H_OPTIONS_H
#define H_OPTIONS_H

struct timestep {
	float	ts_start;
	float	ts_end;
	float	ts_step;
	float	ts_current;
	int	ts_number;
	int	ts_valid;
};

void	ts_info(struct timestep *ts);
void	ts_init(struct timestep *ts);
int	ts_next(struct timestep *ts);
float	ts_step(struct timestep *ts);


struct options {
	int	 op_type;
	char	*op_explain;	/* help message */
	char	*op_default;	/* default value */
	char	*op_range;	/* for range check */
	char	*op_name;	/* option name */
	int	 op_namelen;	/* option name length */
	int	 op_already;	/* indicator to show whether this option read */
	struct timestep *op_timestep;	/* for special case of timestep */
	struct options *op_next;
	struct options *op_prev;
};

#define	OPT_NONE	0x00000000
#define	OPT_INTEGER	0x00000001
#define	OPT_REAL	0x00000002
#define OPT_TIMESTEP	0x00000003
#define OPT_STRING	0x00000004

#define OPT_MAX	OPT_STRING

extern struct options *oproot;

void	 opt_init(const char *filename);
void	 opt_setup(void);
void	 opt_print(void);
void	 opt_check(void);
void	 opt_read(const char *filename);

/* read operation */
void	 opt_add(int, const char *, const char *, const char *, const char *);
int	 opt_getint(const char *optioname);
float	 opt_getreal(const char *optioname);
char 	*opt_getstr(const char *optioname);
struct timestep *opt_gettimestep(const char *optionname);
	
#endif
