#include <stdio.h>
#include <math.h>
#include "common.h"
#include "complex.h"
#include "matrix.h"

inline struct duplex_t **
zmat(const struct matrix_t *mp)
{
	m_typecheck(__F, 1, mp, SP_DUPLEX);
	return (struct duplex_t **) mp->mt_data;
}

/* 
 * returns 0 if ok
 */
int
zm_szcheck(const struct matrix_t *mp, int row, int col)
{
	m_typecheck(__F, 1, mp, SP_DUPLEX);

	if (mp->mt_row != row || mp->mt_col != col) {
		printf("%s(): matrix %s does not have %d rows and %d cols", __F,
			mp->mt_name, row, col);
		return 1;
	}
	return 0;
}

inline struct duplex_t *
zm_row(const struct matrix_t *mp, int row)
{
	m_typecheck(__F, 1, mp, SP_DUPLEX);

	return ((struct duplex_t *) mp->mt_data[row]);
}

int
zm_issymmet(const struct matrix_t *mp)
{
	int	i, j;
	struct duplex_t	**data, tmp;

	data = zmat(mp);
	for (i=0;i< mp->mt_row;i++)
		for (j=0;j < i;j++) {
			if (zp_absolute(zp_minus(&tmp,
				&data[i][j], &data[j][i])) > CUTOFF)
				return 0;
		}
	return 1;
}
