#include <stdio.h>
#include <math.h>
#include "common.h"
#include "complex.h"
#include "matrix.h"

inline struct simplex_t **
cmat(const struct matrix_t *mp)
{
	m_typecheck(__F, 1, mp, SP_SIMPLEX);
	return (struct simplex_t **) mp->mt_data;
}


/* 
 * returns 0 if ok
 */
int
cm_szcheck(const struct matrix_t *mp, int	row, int col)
{
	m_typecheck(__F, 1, mp, SP_SIMPLEX);

	if (mp->mt_row != row || mp->mt_col != col) {
		(void) printf("matrix %s does not have %d rows and %d cols",
			mp->mt_name, row, col);
		return 1;
	} else
		return 0;
}

inline struct simplex_t *
cm_row(const struct matrix_t *af, int row)
{
	m_typecheck(__F, 1, af, SP_SIMPLEX);

	return ((struct simplex_t *) af->mt_data[row]);
}

int
cm_issymmet(const struct matrix_t *af)
{
	int	i, j;
	struct simplex_t **data, ctmp;

	data = cmat(af);
	for (i=0;i< af->mt_row;i++)
		for (j=0;j < i;j++) {
			if (cp_absolute(cp_minus(&ctmp,
				&data[i][j], &data[j][i])) > CUTOFF)
				return 0;
		}
	return 1;
}
