#include <stdio.h>
#include "common.h"
#include "matrix.h"
#include "sparse.h"

struct matrix_t *
sp_tomat(const struct sparse_t *sp)
{
	int	i, j;
	float		 **sm, *sptr;
	double		 **dm, *dptr;
	struct simplex_t **cm, *cptr;
	struct duplex_t  **zm, *zptr;
	struct matrix_t *retm;

	sp_check(__F, 1, sp);
	retm = matrix(sp->sp_rown, sp->sp_coln, NULL, sp->sp_type);
	switch (sp->sp_type) {
		case SP_SINGLE:
			sptr = ssp(sp);
			sm = smat(retm);
			for (i=0;i<sp->sp_coln;i++)
				for (j=sp->sp_colx[i];j<sp->sp_colx[i+1];j++)
					sm[sp->sp_rowx[j]][i] = sptr[j];
			break;
		case SP_DOUBLE:
			dptr = dsp(sp);
			dm = dmat(retm);
			for (i=0;i<sp->sp_coln;i++)
				for (j=sp->sp_colx[i];j<sp->sp_colx[i+1];j++)
					dm[sp->sp_rowx[j]][i] = dptr[j];
			break;
		case SP_SIMPLEX:
			cptr = csp(sp);
			cm = cmat(retm);
			for (i=0;i<sp->sp_coln;i++)
				for (j=sp->sp_colx[i];j<sp->sp_colx[i+1];j++)
					cp_assign(&cm[sp->sp_rowx[j]][i],
						&cptr[j]);
			break;
		case SP_DUPLEX:
			zptr = zsp(sp);
			zm = zmat(retm);
			for (i=0;i<sp->sp_coln;i++)
				for (j=sp->sp_colx[i];j<sp->sp_colx[i+1];j++)
					zp_assign(&zm[sp->sp_rowx[j]][i],
						&zptr[j]);
			break;
	}
	return retm;
}
