#include <stdio.h>
#include "options.h"

void
ts_info(struct timestep *ts)
{
	if (ts == NULL) {
		(void)fprintf(stderr, "ts_info(): NULL pointer");
		exit(1);
	}
	(void) printf("TS_INFO=[%5.2f->%5.2f->%5.2f]:step=%5.2f\n",
			ts->ts_start, ts->ts_current, ts->ts_end, ts->ts_step);
	return;
}

int
ts_next(struct timestep *ts)
{
	if (ts == NULL) {
		(void)fprintf(stderr, "ts_info(): NULL pointer");
		exit(1);
	}
	ts->ts_current += ts->ts_step;
	if (ts->ts_current > ts->ts_end)
		ts->ts_valid = 0;
	return ts->ts_valid;
}

void
ts_init(struct timestep *ts)
{
	if (ts == NULL) {
		(void)fprintf(stderr, "ts_info(): NULL pointer");
		exit(1);
	}
	ts->ts_current = ts->ts_start;
	ts->ts_valid = 1;
	return;
}

float
ts_step(struct timestep *ts)
{
	if (ts == NULL) {
		(void)fprintf(stderr, "ts_info(): NULL pointer");
		exit(1);
	}
	return ts->ts_step;
}
