#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"
#include "finite.h"

int	mesh_getbdint(char *line);

int
mesh_getbdint(char *line)
{
	char	*p;
	int	num;

	for (p=line; isspace(*p); p++) /* skip white space */
		/* void */;

	if (p == NULL)
		fatal("This is not possible!!!");

	num = atoi(p);
	if (num < 0 || num > 31)
		fatal("negative boundary indicator number??");
	return num;
}

struct node_t **
mesh_nodesbuf(const int total)
{
	struct node_t *ndp, **ndpp;
	int	i, size;

	ndpp = (struct node_t **)
		malloc((size_t)(sizeof(struct node_t *) * total));

	if (ndpp == NULL)
		memerr("[0] malloc meshes->m_nodes");

	size = sizeof(struct node_t)*total;
	ndp = (struct node_t *) malloc(size);
	if (ndp == NULL)
		memerr("[1] malloc meshes->m_nodes");
	memset(ndp, 0x00, size);

	for (i=0;i<total;i++, ndp++)
		ndpp[i] = ndp;

	return (ndpp);
}


struct ement_t **
mesh_ementsbuf(const int total)
{
	struct ement_t *emp, **empp;
	int	i, size;

	empp = (struct ement_t **)
		malloc((size_t)(sizeof(struct ement_t *) * total));

	if (empp == NULL)
		memerr("[0] malloc meshes->m_ements");

	size = sizeof(struct ement_t)*total;
	emp = (struct ement_t *) malloc(size);
	memset(emp, 0x00, size);
	if (emp == NULL)
		memerr("[1] malloc meshes->m_nodes");

	for (i=0;i<total;i++, emp++)
		empp[i] = emp;

	return (empp);
}
