#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "finite.h"

struct einfo_t {
	short	 ei_alloced;
	short	 ei_cnt;
	nodno_t	*ei_ements;
};

#define FIFTEEN 15
int	einfo_comp(const nodno_t *one, const nodno_t *two);

void
mk_nearements(void)
{
	int	i, j;
	struct einfo_t **eiroot, *eip;
	nodno_t *nnp, *nnp2;
	struct ement_t *ep;
	struct node_t *np;
	int	(*comp)();

	if (meshes->m_nodes[0]->n_ements) /* already called */
		return;
	eiroot = (struct einfo_t **)
		malloc(sizeof(struct einfo_t *) * meshes->m_nodesno);
	if (eiroot == NULL)
		memerr("%s(): eiroot = NULL", __F);
	eip = (struct einfo_t *)
		malloc(sizeof(struct einfo_t) * meshes->m_nodesno);
	if (eip == NULL)
		memerr("%s(): eip == NULL", __F);

	for (i=0; i < meshes->m_nodesno; i++, eip++) {
		eiroot[i] = eip;
		eip->ei_cnt = 0;
		eip->ei_alloced = FIFTEEN;	/* enough ? */
		eip->ei_ements = (nodno_t *) malloc(sizeof(nodno_t) * FIFTEEN);
		if (eip->ei_ements == NULL)
			memerr("%s(): [2]", __F);
	}

	for (i=0; i < meshes->m_ementsno; i++) {
		ep  = meshes->m_ements[i];
		nnp = ep->e_nodes;
		for (j=0; j < ep->e_nodesno; j++) {
			eip = eiroot[nnp[j]];
			if (eip->ei_cnt == eip->ei_alloced)
				fatal("%s(): [3]", __F);
			eip->ei_ements[eip->ei_cnt] = i;
			eip->ei_cnt++;
		}
	}

	comp = einfo_comp;
	for (i=0; i < meshes->m_nodesno; i++) {
		np  = meshes->m_nodes[i];
		eip = eiroot[i];
		qsort(eip->ei_ements, eip->ei_cnt, sizeof(nodno_t), comp);
		np->n_ements = nnp2 = (nodno_t *)
			malloc(sizeof(nodno_t) * eip->ei_cnt);
		if (nnp2 == NULL)
			memerr("%s(): [4]", __F);
		nnp = eip->ei_ements;
		memcpy(nnp2, nnp, sizeof(nodno_t) * eip->ei_cnt);
		np->n_ementsno = eip->ei_cnt;
	}

	/* free */
	for (i=0; i<meshes->m_nodesno; i++) {
		free(eiroot[i]->ei_ements);
	}
	free(eiroot[0]);
	free(eiroot);

	return;
}


int
einfo_comp(const nodno_t *one, const nodno_t *two)
{
	if (*one > *two)
		return 1;
	else if (*one < *two)
		return -1;
	fatal("%s(): two are same", __F);
	return 0;
}
