#include <stdio.h>
#include <string.h>
#include <strings.h>
#ifdef sgi
#include <bstring.h>	/* for Irix5.2 */
#endif
#include <stdlib.h>
#include <ctype.h>

#include "common.h"
#include "finite.h"

int	tri_putnodes(FILE *);
int	tri_putements(FILE *);


void
tri_putmesh(const char *nof, const char *emf)
{
	FILE	*fp;

	fp = fopen(nof, "w");
	if (fp == NULL)
		fatal("tri_putmesh(\"%s\", \"%s\"): can not open node file",
			nof, emf);
	tri_putnodes(fp);
	fclose(fp);

	fp = fopen(emf, "w");
	if (fp == NULL)
		fatal("tri_putmesh(\"%s\", \"%s\"): can not open ement file",
			nof, emf);
	tri_putements(fp);
	fclose(fp);

	return;
}

/*
 * for showme(1) of triangle
 * A Pivate function of tri_putmesh
 */

int
tri_putnodes(FILE *fp)
{
	int	i;
	struct node_t	**npp;

	npp = meshes->m_nodes;
	if (npp == NULL)
		fatal("Really fatal error in putnodes()");
	fprintf(fp, "%4d %3d 0 1\n", meshes->m_nodesno, meshes->m_spacedim);
	for (i = 0; i< meshes->m_nodesno; i++) {
		(void) fprintf(fp, "%4d ", (npp[i]->n_no + 1));
		(void) fprintf(fp, "%8.4f %8.4f 0 \n",
			npp[i]->n_coor[0],
			npp[i]->n_coor[1]);
	}
	return 0;
}

/*
 * A Pivate function of tri_putmesh
 */

int
tri_putements(FILE *fp)
{
	int	i, j;
	struct ement_t	**epp;

	epp = meshes->m_ements;
	if (epp == NULL)
		fatal("Really fatal error in tri_putements()");

	fprintf(fp, "%4d %2d 0\n", meshes->m_ementsno, epp[0]->e_nodesno);;
	for (i = 0; i< meshes->m_ementsno; i++) {
		(void) fprintf(fp, "%4d  ", epp[i]->e_no + 1);
		for (j=0; j < epp[i]->e_proto->p_nodsno; j++)
			(void) fprintf(fp, "%6d  ", (epp[i]->e_nodes[j]) + 1);
		(void) fprintf(fp, "\n");
	}
	return 0;
}
