#include <stdio.h>
#include <stdlib.h>

#include "common.h"
#include "finite.h"

/*
 * code for the test of the quadratic element
 * case 4 does not give good result!!!!!!! IT IS VERY STRANGE TO ME
 *
 * The equation:
 *	\nabla^2\phi(x, y) = f(x,y) in 0<x,y<1 
 *		where f(x,y) = 2x(x-1)+2y(y-1): see mkright()
 *		with Dirichlet boundary condition that
 *			\phi(x,y) = 0 at boundaries
 *
 *		exact sol:
 *			\phi(x,y) = x(x-1)y(y-1)
 */

int
main(int argc, char *argv[])
{
	int which;

	if (argc != 2)
		fatal("%s(): need at least one argument", __F);
	which = atoi(argv[1]);

	mesh_init(SP_DOUBLE);

	switch (which) {
		case 0:
			tri_getmesh("square.1");
			break;
		case 1:
			tri_getmesh("square.2");
			break;
		case 2:
			genm_linear("d=2 [0.0:1.0]x[0.0:1.0]",
				"d=2 [4:4] [1.0:1.0]");
			break;
		case 3:
			genm_quadrat(0, "d=2 [0.0:1.0]x[0.0:1.0]",
				"d=2 [4:4] [1.0:1.0]");
			break;
		case 4:
			genm_quadrat(1, "d=2 [0.0:1.0]x[0.0:1.0]",
				"d=2 [4:4] [1.0:1.0]");
			break;
		default:
			fatal("%s(): Your argument is not good", __F);
	}
	dp_putmesh("b.grids");
	put_2dgrids("grids.mtv", 1);

	meshes->m_kmatrix = create_kmatrix();
	meshes->m_bvector = create_bvector();

	problem();
	(void) printf("End of processing of\n");
	return 0;
}
