#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include "common.h"
#include "vector.h"
#include "sparse.h"
#include "solver.h"
#include "rtc.h"

double	escape = 1e-8;

struct vector_t *
it_sorforward(struct sparse_t *sp, struct vector_t *x, struct vector_t *b,
	int itno, double omega)
{
	int	dimen;
	struct vector_t *r, *tmp0, *tmp1;
	double	bnorm;
	int	i;
	struct sparse_t *diag, *dinv;

	iter_bontriplets(__F, sp, x, b);

	r = vec_puredup(x);
	tmp0 = vec_puredup(x);
	tmp1 = vec_puredup(x);

	dimen = x->vt_size;
	bnorm = vec_getnorm2(x);

	if (!iszero(vec_getnorm1(x)/(double) dimen))
		vec_copy(r, vec_minus(tmp0, b, sp_dotvec(tmp1, 0, sp, x)));
	else
		vec_copy(r, b);

	i = 0;
	diag = sp_getdiagsp(sp);
	dinv = sp_getinvdiag(diag);
	while (iter_check(i, vec_getnorm2(r), bnorm) && i < itno) {
		i++;

		vec_dcross(tmp1, omega, sp_dotvec(tmp0, 0, dinv, r));
		vec_plus(x, x, tmp1);
		if (i < itno)
			vec_minus(r, b, sp_dotvec(tmp0, 0, diag, x));
		if (verbose)
			printf("%4d\n", i);
	}
	vec_mfree(3, r, tmp0, tmp1);
	return x;
}
