#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include "vector.h"
#include "sparse.h"
#include "solver.h"
#include "precond.h"
#include "rtc.h"

#define jacob

/*
JacobiIter
ProcondProcType
 */

/*
 * Jacobian Interation Method
 * Should the diagonal of sp be always to be NONZERO???
 *
 */
struct vector_t *
it_jacob(struct sparse_t *sp, struct vector_t *x, struct vector_t *b,
	int MaxIter, PrecondProcType Dummy, double Omega)
{
	int iter;
	double bnorm;
	struct vector_t *r;
	struct vector_t *atmp, *btmp, *diag;

	iter_bontriplets(__F, sp, x, b); /* check them */

	r    = vec_puredup(x);
	atmp = vec_puredup(x);
	btmp = vec_puredup(x);
	diag = vec_puredup(x);

	bnorm = vec_getnorm2(b);

	iter = 0;
	/* r = b - A * x(i) */

	if (!iszero(vec_getnorm1(x) / (double) x->vt_size)) {
#if 0
		if (Q_KerDefined(A))
			OrthoRightKer_VQ(x, A);
#endif
		vec_copy(r, vec_minus(btmp, b, sp_dotvec(atmp, 0, sp, x)));
	} else {
		vec_copy(r, b);
	}
	
	diag = sp_getdiagvec(diag, sp);

	while (!RTCResult(iter, vec_getnorm2(r), bnorm, JacobiIterId)
	    && iter < MaxIter) {
		iter++;
		/* x(i+1) = x(i) + Omega * D^(-1) * r */

		vec_copy(x, vec_crossd(atmp,
			vec_inverseplus(btmp, diag, r), Omega));

#if 0
		if (Q_KerDefined(A))
			OrthoRightKer_VQ(x, A);
		/* r = b - A * x(i) */
#endif
		if (iter < MaxIter)
			vec_copy(r,
				vec_minus(btmp, b, sp_dotvec(atmp, 0, sp, x)));
	}

	vec_mfree(4, r, atmp, btmp, diag);

	return(x);
}
