#ifndef PRECOND_H
#define PRECOND_H


typedef struct vector_t *(*PrecondProcType)(struct sparse_t *,
		struct vector_t *, struct vector_t *, double);

/* declaration of preconditioners */

struct vector_t *JacobiPrecond(struct sparse_t *A,
			struct vector_t *y, struct vector_t *c, double Omega);
struct vector_t *SSORPrecond(struct sparse_t *A,
			struct vector_t *y, struct vector_t *c, double Omega);
struct vector_t *ILUPrecond(struct sparse_t *A,
			struct vector_t *y, struct vector_t *c, double Omega);

#endif /* PRECOND_H */
