#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include "rtc.h"
#include "solver.h"

/* accuracy for Residual Termination Control */
double RTCEps = 1e-8;

/* auxiliary procedure to be performed by Residual Termination Control */
RTCAuxProcType RTCAuxProc = NULL;

/* number of iterations performed during last call of a iteration method */
int LastNoIter = 0;

/* accuracy reached during last call of a iteration method */
double LastAcc = 0.0;

/* set accuracy for the RTC */
void SetRTCAccuracy(double Eps)
{
    RTCEps = Eps;
}

/* set auxiliary procedure of RTC */
void SetRTCAuxProc(RTCAuxProcType AuxProc)
{
    RTCAuxProc = AuxProc;
}

/* get result of RTC */
int RTCResult(int Iter, double rNorm, double bNorm, IterIdType IterId)
{
	int Result;

#if 0
	if (LASResult() == 0)
#endif
	if (0 == 0) {
		if (rNorm < RTCEps * bNorm
		    || (iszero(bNorm) && isone(1.0 + rNorm)))
			Result = 1;
		else
			Result = 0;

		LastNoIter = Iter;

		if (!iszero(bNorm))
			LastAcc = rNorm / bNorm;
		else
			LastAcc = 1.0;

		if (RTCAuxProc != NULL)
			(*RTCAuxProc)(Iter, rNorm, bNorm, IterId);
	} else {
		Result = 1;
	}

	return(Result);
}

/* get number of iterations performed during last call of a iteration method */
int GetLastNoIter()
{
	return(LastNoIter);
}

/* get accuracy reached during last call of a iteration method */
double GetLastAccuracy()
{
	return(LastAcc);
}
