#ifndef RTC_H
#define RTC_H

#if 0
#include "laspack/lastypes.h"
#include "laspack/vector.h"
#include "laspack/itersolv.h"
#include "laspack/copyrght.h"
#endif

/* identifiers for iteration methods */

typedef enum {
	/* classical iterative methods */
	JacobiIterId,
	SORForwIterId,
	SORBackwIterId,
	SSORIterId,

	/* semi-iterative methods */
	ChebyshevIterId,

	/* CG and CG-like methods */
	CGIterId,
	CGNIterId,
	GMRESIterId,
	BiCGIterId,
	QMRIterId,
	CGSIterId,
	BiCGSTABIterId,

	/* multigrid and multigrid based methods */
	MGIterId,
	NestedMGIterId,
	MGPCGIterId,
	BPXPCGIterId
} IterIdType;

typedef void (*RTCAuxProcType)(int, double, double, IterIdType);

void	SetRTCAccuracy(double Eps);
void	SetRTCAuxProc(RTCAuxProcType AuxProc);
int	RTCResult(int Iter, double rNorm, double bNorm, IterIdType IterId);
int	GetLastNoIter(void);
double	GetLastAccuracy(void);

#endif /* RTC_H */
