#include <stdio.h>
#include <sys/types.h>
#include <string.h>

#include "common.h"
#include "sparse.h"
#include "randfile.h"
#include "updown.h"

void mat_nonzero(struct matrix_t *a);
int mkband(int i, int j)
{
	if (i == j || abs(i-j) == 19 || abs(i-j) == 10 || abs(i-j) == 5)
		return 0;
	return 1;
}


int
main(void)
{
	char right[132], left[132];
	struct sparse_t *sp;
	struct vector_t *x, *b, *bcopied,  *ret;
	struct vector_t *indx;
	struct matrix_t *am, *bm, *lower, *upper;
	struct matrix_t *copied;
	float	tmp;
	
	strcpy(right, "right.");
	strcpy(left, "left.");
	strcat(right, "0");
	strcat(left, "0");

	if (1)
		gen_randomfile2nd(10, SP_SINGLE, 0, mkband, right, left);
	else
		gen_randomfile(100, SP_SINGLE, 1, 9, right, left);

	sp = sp_read(left);
	b  = vec_read(right);
	bcopied  = vec_dup(b);
	x  = vec_puredup(b);
	ret= vec_puredup(b);

	sp_putusingrow(sp, "%7.3f", NULL);


	am = sp_tomat(sp);
	copied = m_dup(am);
	bm = m_puredup(am);
        indx = vector(am->mt_col, "tmp", SP_INTEGER);

        mat_ludecomp(am, indx, &tmp, 0);
        lower = m_getlower(am);
        upper = m_getupper(am);

        vec_print(indx);
        m_mput(2, lower, upper);
        m_dot(bm, lower, upper);


	m_pattern(upper);
	m_pattern(lower);
	m_pattern(copied);
	/*
	 * copied and bm should be same
	 */
	m_mput(2, copied, bm);

	mat_lubacksub(am, indx, b);
	m_dotvec(x, copied, b);
	vec_pairprint(x, bcopied);

	printf("++%10.8f++\n", m_compare(copied, bm));
	printf("++%10.8f++\n", vec_unitdiff(x, bcopied));
	

	return 0;
}

void
mat_nonzero(struct matrix_t *a)
{
        printf("%4d = The no of nonzeros of %s\n", m_nonzeros(a), a->mt_name);
        return;
}

