#include <stdio.h>
#include <sys/types.h>
#include <string.h>

#include "common.h"
#include "sparse.h"
#include "randfile.h"
#include "updown.h"
#include "sp_lu.h"

void mat_nonzero(struct matrix_t *a);
int mkband(int i, int j)
{
	int	dif;
	dif = abs(i-j);
	switch (dif) {
		case 0:
		case 3:
		case 5:
		case 9:
		case 10:
			return 0;
	}
	return 1;
}


int
main(void)
{
	char right[132], left[132];
	struct sparse_t *sp;
	struct spforlu_t *spf;
	struct vector_t *x, *b, *bcopied;
	
	strcpy(right, "right.");
	strcpy(left, "left.");
	strcat(right, "0");
	strcat(left, "0");

	if (0)
		gen_randomfile2nd(100, SP_SINGLE, 1, mkband, right, left);
	else
		gen_randomfile(10, SP_SINGLE, 1, 9, right, left);

	sp = sp_read(left);
	if (1)
		sp_putusingrow(sp, "%5.1f", "+");

	x  = vec_read(right);
	b  = vec_puredup(x);
	bcopied  = vec_dup(x);

	spf = sp_ludecomp(sp, 1);
	splu_check(spf, __F);
	sp_lubacksub(spf, x);
	sp_dotvec(b, 0, sp, x);

	vec_pairprint(b, bcopied);

	return 0;
}

void
mat_nonzero(struct matrix_t *a)
{
        printf("%4d = The no of nonzeros of %s\n", m_nonzeros(a), a->mt_name);
        return;
}
