#include <stdio.h>
#include <sys/types.h>
#include <string.h>

#include "common.h"
#include "randfile.h"
#include "sparse.h"
#include "updown.h"

void mat_nonzero(struct matrix_t *a);

int mkband(int i, int j)
{
	if (i == j || abs(i-j) == 4 || abs(i-j) == 3 || abs(i-j) == 5)
		return 0;
	return 1;
}

int
main(void)
{
	char right[132], left[132];
	struct sparse_t *sp;
	struct vector_t *x, *b;
	struct matrix_t *mtmp0, *mtmp1;
	struct matrix_t *am, *copied, *diagmat, *rightm;
	struct matrix_t *check;
	struct vector_t *diagv, *vtmp0, *vtmp1;
	struct vector_t *bcopied;
	
	strcpy(right, "right.");
	strcpy(left, "left.");
	strcat(right, "0");
	strcat(left, "0");
	if (0)
		gen_randomfile2nd(5, SP_DUPLEX, 0, mkband, right, left);
	else
		gen_randomfile(6, SP_SINGLE, 1, 3, right, left);

	sp = sp_read(left);
	b  = vec_read(right);
	bcopied = vec_dup(b);
	x  = vec_puredup(b);
	vtmp0  = vec_puredup(b);
	vtmp1  = vec_puredup(b);
#if 1
	sp_putusingrow(sp, "%10.3e", "+");
#endif

	am = sp_tomat(sp);
	m_put(am);
#if 0
exit(1);
#endif
	rightm = m_puredup(am);
	copied = m_dup(am);
	mtmp0= m_puredup(am);
	mtmp1= m_puredup(am);
	check= m_puredup(am);
        diagv = vector(am->mt_col, "tmp", SP_SINGLE);

        mat_nonzero(am);
#if 0
	printf("start------\n");
	m_print(am);
	printf("start------\n");
#endif
        m_svdcmp(am, diagv, rightm);
	diagmat = m_mkdiagmat(diagv);
	m_dott(mtmp0, diagmat, rightm);
	m_mkdiaginv(diagmat);
	m_dot(mtmp1, am, mtmp0);

#if 0
	m_print(mtmp1);
	m_print(copied);
#endif
	printf("++%f++\n", m_compare(copied, mtmp1));
	if (1)
		m_mput(4, am, mtmp0, diagmat, rightm);
	
	
#if  1
	m_tdot(check, rightm, rightm);
	m_put(check);
	m_tdot(check, am, am);
	m_put(check);
#endif
	if (1) { /* check */
		m_tdotvec(vtmp0, am, b);
		m_dotvec(vtmp1, diagmat, vtmp0);
		m_dotvec(vtmp0, rightm, vtmp1); /* sol */
		m_dotvec(vtmp1, copied, vtmp0); /* b? */
		vec_pairprint(bcopied, vtmp1);
	}

	return 0;
}
void
mat_nonzero(struct matrix_t *a)
{
        printf("%4d = The no of nonzeros of %s\n", m_nonzeros(a), a->mt_name);
        return;
}

