#include <stdio.h>
#include "common.h"
#include "finite.h"

void	usage(void);

int
main(int argc, char **argv)
{
	char	fname[256], cmd[256];
	int	needno;
	/*
	 * Setup mesh global structure
	 * You should call these two function!!!!
	 * TRUE of mesh_init(complexornot) means that the whole structure will
	 * use complex variable... I mean, K-mat b-mat etc are complex structure
	 * when you gave me TRUE argument.
	 */

	needno = 0;
	if (argc == 1 || argc > 3)
		usage();
	if (argc == 3) {
		if (strcmp(argv[1], "-n"))
			usage();
		else {
			argc--;
			argv++;
		}
		needno++;
	}

	mesh_init(SP_SINGLE);

	dp_getmesh(argv[1]);
	sprintf(fname, "%s.mtv", argv[1]);
	put_2dgrids(fname, needno);
	sprintf(cmd, "plotmtv %s &", fname);
	system(cmd);
	return 0;
}

void
usage(void)
{
	char *list[]={"This is an executable which enables me to view the grid",
		"file that was created by the diffpack package", NULL};
	char **p;

	p = list;
	while (*p)
		printf("%s\n", *p++);

	printf("usage: a.out [-n] gridfilename\n");
	exit(1);
}
