#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "minmax.h"

int
main(int argc, char **argv)
{
	FILE	*fp, *fout;
	float	x, y;
	float	min[2], max[2];
	char	line[256], new[256];
	int	readn, cnt, total;
	char	command[256];
	struct value_t **values, *vp;
	int	(*compare)();
	int	i;

	if (argc != 2)
		exit(1);

	fp = fopen(argv[1], "r");
	if (fp == NULL)
		err("[0] can not open");

	min[0] = +1.0e-30;
	max[0] = -1.0e-30;
	min[1] = +1.0e-30;
	max[1] = -1.0e-30;
	cnt = 0;
	while (fgets(line, 256, fp)) {
		readn = sscanf(line, "%f %f", &x, &y);
		if (readn != 2)
			err("sscanf");
		if (min[0] > x)
			min[0] = x;
		if (max[0] < x)
			max[0] = x;

		if (min[1] > y)
			min[1] = y;
		if (max[1] < y)
			max[1] = y;
		cnt++;
	}
	fclose(fp);
	total = cnt;

	values = (struct value_t **) malloc(sizeof(struct value_t *) * total);
	if (values == NULL)
		err("err in values");

	vp = (struct value_t *) malloc(sizeof(struct value_t) * total);
	if (vp == NULL)
		err("err in vp");

	for (i=0; i < cnt; i++)
		values[i] = vp++;

	/*
	 * end of malloc
	 */

	fp = fopen(argv[1], "r");
	if (fp == NULL)
		err("[0] can not open");

	cnt=0;
	while (fgets(line, 256, fp)) {
		readn = sscanf(line, "%f %f", &x, &y);
		values[cnt]->v_x = x;
		values[cnt]->v_y = y;
		if (readn != 2)
			err("sscanf");
		cnt++;
	}
	fclose(fp);

	compare = value_cmp;
	qsort(values, total, sizeof(struct value_t *), compare);

	strcpy(new, argv[1]);
	strcat(new, ".tmp");
	fout = fopen(new, "w");
	if (fout == NULL)
		err("[1]can not open");

	fprintf(fout, "$ DATA=CURVE2D\n");
	fprintf(fout, "%% linetype=0 filltype=0\n");
	fprintf(fout, "%7.3f %7.3f\n", min[0], minmax(min[1]));
	fprintf(fout, "%7.3f %7.3f\n\n", minmax(max[0]), minmax(max[1]));
	
	for (i=0; i < (total-1); i++) {
		fprintf(fout,
		"@ line x1=%12.5e y1=%12.5e x2=%12.5e y2=%12.5e linetype=1\n", 
			values[i]->v_x, values[i]->v_y,
			values[i+1]->v_x, values[i+1]->v_y);
	}
	fclose(fout);

	strcpy(command, PLOTMTV);
	strcat(command, " -nodate -pbg white -pfg black -scale 0.7 ");
	strcat(command, new);
	strcat(command, "&");
	system(command);
	return 0;
}
