#include <stdio.h>
#include <math.h>
#include "minmax.h"

void
err(const char *msg)
{
	printf("%s\n", msg);
	exit(1);
}

int
value_cmp(const struct value_t **onep, const struct value_t **twop)
{
	struct value_t *one, *two;

	one = (struct value_t *) *onep;
	two = (struct value_t *) *twop;
	if (one->v_x > two->v_x)
		return 1;
	else if (one->v_x < two->v_x)
		return -1;
	return 0;
}

double
minmax(double x)
{
	int     iunit, idiv;
	double   unit, logged, ret;
	double   sign;

	if (x < 0) {
		sign = -1.0;
		x *= -1.0;
	} else if (x == 0.0)
		return 0.0;
	else
		sign = 1.0;

	logged = log10(x);
	iunit = (int) logged;
	if (logged < 0.0)
	iunit -= 1;
	unit = pow(10, (double) iunit);
	idiv = (int) (x / unit);
	ret = ((double) (idiv+1)) * unit;

	ret *= sign;
	printf("%f %f\n", unit, ret);
	return ret;
}
